#sitecreds for leafs

set sitecreds(users) "/glftpd/ftp-data/users/" ; #eggdrop user must have write and read access
set sitecreds(tmp) "/tmp/" ; #eggdrop user must have all access here (temp files)
set sitecreds(hub) "HubBotName" ; #Bothandle its known as
set sitecreds(chan) "#Chan" ; #Chan to warn if bad user

bind msg -|- transfer msg:sitecreds:transfer

proc isnumber {num} {
 if {$num==""} { return 0 }
 return [string is digit $num]
}

proc msg:sitecreds:transfer {nick uhost handle text} {
 set type [join [lindex $text 0]]
 set user [join [lindex $text 1]]
 set pass [join [lindex $text 2]]
 set mbs [join [lindex $text 3]]

 set type [string tolower $type]
 
if {$mbs=="" || $user=="" || $pass==""} { set type "" }

if {$mbs != ""} {
 set ok 1
 if {![isnumber $mbs]} { set ok 0 }

 if {$ok==1} {
  if {$mbs < 100 || $mbs > 10000} { set ok 0 }
 }

 if {$ok==0} {
   putserv "PRIVMSG $nick :You can transfer atleast 100MB and maximum 10GB in one command."
   putserv "PRIVMSG $nick :Usage: transfer type user pass mb"
   return 0
 }
}

 switch -exact -- $type {
  "take" { sitecreds:take $nick $user $pass $mbs }
  "give" { sitecreds:give $nick $user $pass $mbs }
  "default" {
   putserv "PRIVMSG $nick :Usage: transfer type user pass mb"
   putserv "PRIVMSG $nick :user is your login on ftp"
   putserv "PRIVMSG $nick :Type can be take or give"
   putserv "PRIVMSG $nick :To transfer between slaves, first give to hub and take on the other slave."
   putserv "PRIVMSG $nick :If you take too many credits, you will get the amount you have, same applies to give."
  }
}
}

proc sitecreds:take {nick user pass mbs} {
global sitecreds sitecredsnicks binary location

 #Sets mbs to be kbs now (since its kbs we write in the user files)
 set mbs [expr $mbs * 1024]

 #Checking user pass
 set result [exec $binary(PASSCHK) $user $pass $location(PASSWD)]
 if {![string match "MATCH" $result]} {
  putserv "PRIVMSG $sitecreds(chan) :$nick![getchanhost $nick] tried to transfer credits for $user using bad pass"
  return 0
 }

 if {![islinked $sitecreds(hub)]} {
  putserv "PRIVMSG $nick :hub is unlinked now, trying to link (Please retry in a few secs, if problem presist msg a siteop)"
  link $sitecreds(hub)
 }
 #take from hub
 set sitecredsnicks($user) $nick 
 putbot $sitecreds(hub) "sitecreds take $user $mbs"
 #We will recieve a giveans $mbs or negativecreds or badtakeuser $user
}

proc sitecreds:give {nick user pass mbs} {
 #Sets mbs to be kbs now (since its kbs we write in the user files)
 set mbs [expr $mbs * 1024]

 #Checking user pass
 global binary location sitecreds
 set result [exec $binary(PASSCHK) $user $pass $location(PASSWD)]
 if {![string match "MATCH" $result]} {
  putserv "PRIVMSG $sitecreds(chan) :$nick![getchanhost $nick] tried to transfer credits for $user using bad pass"
  return 0
 }

global sitecreds sitecredsnicks
 #give to hub
 if {![islinked $sitecreds(hub)]} {
  putserv "PRIVMSG $nick :hub is unlinked now, trying to link (Please retry in a few secs, if problem presist msg a siteop)"
  link $sitecreds(hub)
 }

 set isuser [sitecreds:isuser $user]
 if {$isuser == 0} { putserv "PRIVMSG $nick :Bad user" ; return 0 }

 set sitecredsnicks($user) $nick
 set credits [sitecreds:getcredits $user]
 if {$mbs > $credits} {
  putserv "PRIVMSG $nick :You dont have $mbs credits, transfering $credits"
  set mbs $credits
 }
 if {$mbs < 0} { putserv "PRIVMSG $nick :You have negative credits, transfer aborted" ; return 0 }

 putserv "PRIVMSG $nick :Attempting to transfer [expr $mbs / 1024] mb to HUB"
 
 putbot $sitecreds(hub) "sitecreds give $user $mbs"
}

bind bot -|- sitecreds bot:sitecreds

proc bot:sitecreds {frombot cmd arg} {
	global sitecreds sitecredsnicks
	#giveans user mbs
	#negativecreds user
	#badtakeuser user
	
	#badgiveuser user
	#takeans user mbs
	
	set type [join [lindex $arg 0]]
	switch -exact -- $type {
		"giveans" {
			set user [join [lindex $arg 1]]
			set mbs [join [lindex $arg 2]]
			set credits [sitecreds:getcredits $user]
			sitecreds:setcredits $user [expr $credits - $mbs]
			set mbs [expr $mbs / 1024]
			putserv "PRIVMSG $sitecredsnicks($user) :$mbs MB transfered to the hub."
		}
		"negativecreds" {
			putserv "PRIVMSG $sitecredsnicks($user) :You have negative credits on the hub (This may be because your userfile is locked, try again in a few mins)."
		}
		"badtakeuser" {
			putserv "PRIVMSG $sitecredsnicks($user) :You dont seem to exist in hub, contact a siteop."
		}
		"badgiveuser" {
			putserv "PRIVMSG $sitecredsnicks($user) :You dont seem to exist in hub, contact a siteop."
		}
		"takeans" {
			set user [join [lindex $arg 1]]
			set mbs [join [lindex $arg 2]]
			set credits [sitecreds:getcredits $user]
			sitecreds:setcredits $user [expr $credits + $mbs]
			set mbs [expr $mbs / 1024]
			putserv "PRIVMSG $sitecredsnicks($user) :$mbs MB transfered to this leaf"
		}
	}
}

source sitecreds/sitecreds.shared.tcl

putlog "Sitecreds for leafs by MORA@EFNet loaded"