#shared procs for sitecreds
proc sitecreds:getcredits {user} {
 global sitecreds
 set res [exec cat $sitecreds(users)$user | grep CREDITS]
 return [join [lindex $res 1]]
}

proc sitecreds:isuser {user} {
 global sitecreds
 return [file exists $sitecreds(users)$user]
}

proc sitecreds:setcredits {user newcredits} {
 global sitecreds
 if {[file exists "$sitecreds(users)$user.lock"]} {
  return -1;
 }
 catch {
 exec touch "$sitecreds(users)$user.lock"
 }
 file copy -force $sitecreds(users)$user $sitecreds(tmp)$user

 set fp [open "$sitecreds(tmp)$user.2" w+]
 set fp2 [open "$sitecreds(tmp)$user" r]
 while {![eof $fp2]} {
  set line [gets $fp2]
  set lin [join [lindex $line 0]]

  if {$lin=="CREDITS"} {

   puts $fp "CREDITS $newcredits"
  } else {

   puts $fp $line
  }
 }
 close $fp
 close $fp2
 file copy -force "$sitecreds(tmp)$user.2" $sitecreds(users)$user
 file delete "$sitecreds(users)$user.lock"
}