#sitecreds for hub

set sitecreds(users) "/glftpd/ftp-data/users/" ; #eggdrop user must have all access here
set sitecreds(tmp) "/tmp/" ; #eggdrop user must have all access here (temp files)

bind bot -|- sitecreds bot:sitecreds

proc bot:sitecreds {frombot cmd arg} {
#   /msg leaf transfer give/take user mb
 set type [join [lindex $arg 0]]
 set user [join [lindex $arg 1]]
 set mbs [join [lindex $arg 2]]
 set type [string tolower $type]

 if {$type=="give"} {
   sitecreds:give $frombot $user $mbs
 }
 if {$type=="take"} {
   sitecreds:take $frombot $user $mbs
 }
}

proc sitecreds:give {frombot user mbs} {
#Give credits here, leaf already made sure user has the credits.
 set isuser [sitecreds:isuser $user]
 if {$isuser == 0} { putbot $frombot "sitecreds badgiveuser $user" ; return 0 }

 set credits [sitecreds:getcredits $user]
 set newcredits [expr $credits + $mbs]
 
 sitecreds:setcredits $user $newcredits
 putloglev 4 * "\[Credits\] $user@$frombot transfers $mbs here"
 putbot $frombot "sitecreds giveans $user $mbs" ; #First when the leaf recieves this, the credits is removed.
}

proc sitecreds:take {frombot user mbs} {
#Take credits from hub to site
 set isuser [sitecreds:isuser $user]
 if {$isuser == 0} { putbot "sitecreds badtakeuser $user" ; return 0 }

 set credits [sitecreds:getcredits $user]
 if {$credits < $mbs} { set mbs $credits }
 if {$mbs < 0} { putbot $frombot "sitecreds negativecreds $user" ; return 0 }

 sitecreds:setcredits $user [expr $credits - $mbs]
 putloglev 4 * "\[Credits\] $user@$frombot transfers $mbs from here"
 putbot $frombot "sitecreds takeans $user $mbs"
}

source sitecreds/sitecreds.shared.tcl

putlog "Sitecreds for hubs by MORA@EFNet loaded!"